/*
    Spakes - a client/server Snakes-clone for up to 4 players
    Copyright (C) 2001, 2002, 2004  Markus Triska

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact me at triska@gmx.at
*/


#include <string>

#include <qwidget.h>

#include "point.h"

class QTimer;
class QPushButton;
class QLineEdit;
class Player;
class UDPSocket;
class QButtonGroup;
class QRadioButton;

class Gameboard : public QWidget
{
	Q_OBJECT
public:

	Gameboard(QWidget *parent = 0, const char *name = 0);
	~Gameboard();

 	void draw_player(Player *, bool fullredraw = false);
	void undraw_player(Player *);
	void announce_player(const Player *);
	void undraw_begin(const Player *);
	void draw_apple(const Point &);

protected:
	void paintEvent(QPaintEvent *);
	void keyPressEvent(QKeyEvent *);
	void keyReleaseEvent(QKeyEvent *);
private slots:
	void start_multiplayer();
	void start_singleplayer();
	void tick();
private:
	void show_controls();
	void hide_controls();
	void get_options();
	void cleanup_game();

	QTimer *timer;
	QPushButton *btnConnect;
	QPushButton *btnSinglePlayer;
	QLineEdit *txtPrimNick, *txtSecNick;
	QLineEdit *txtIP;
	QButtonGroup *secgroup;
	QRadioButton *optAI, *optHuman, *optNone;

	UDPSocket *udpserver;
	std::string primplayername, secplayername;
	int state;
	int primplayerid, secplayerid;
	enum {PL_AI, PL_HUMAN, PL_NONE} secplayer;
};


